      SUBROUTINE QSF9D(RINT,A,B,FUN,RO,FI,N,EPS,K,L1,L2,IND,R,IERR)
         INTEGER IND,K,L1,L2,N
         DOUBLE PRECISION A,B,EPS,FI,R,RINT,RO
         DIMENSION IND(N),R(N,3),RINT(N,2)
         EXTERNAL UTQS12
         INTEGER I,IL,J,J1,J2,J3,J4,K1,KW
         DOUBLE PRECISION ARG,B1,B2,B3,CRH,CS,DL,EC,ES,H,H2,H4,Q,ROH2,
     1                    ROH4,SN,SRH,V,W,WK
         DIMENSION Q(5)
       IL = L1 + L2
       IERR = 0
       DO 10 I = 1, N
          R(I,2) = 0.D0
          R(I,3) = 0.D0
          IND(I) = 0
   10  CONTINUE
       K1 = K
       IF (K .LE. 0) K1 = 1
       DL = B - A
       WK = 0.D0
   20  CONTINUE
       H = DL/K1
       H2 = H/2.D0
       H4 = H2/2.D0
       ROH2 = RO*H2
       SRH = DSIN(ROH2)
       CRH = DCOS(ROH2)
       IF (ROH2 .GT. .33D0) GO TO 30
          ROH4 = RO*H4
          Q(1) = .2666666666666667D0
          Q(2) = .7111111111111111D0*DCOS(ROH4)
          Q(3) = .1555555555555556D0*CRH
          Q(4) = .7111111111111111D0*DSIN(ROH4)
          Q(5) = .1555555555555556D0*SRH
          GO TO 40
   30  CONTINUE
       B1 = 1.D0/ROH2
       B2 = B1*B1
       B3 = B2*B2
       Q(1) = 4.D0*B2*(B1*(48.D0*B2 - 19.D0)*SRH + 3.D0*(1.D0 -
     1        16.D0*B2)*CRH)
       Q(2) = 32.D0*B2*(B1*(5.D0 - 12.D0*B2)*SRH - (1.D0 - 12.D0*
     1        B2)*CRH)/3.D0
       Q(3) = B1*((3.D0 - 46.D0*B2 + 96.D0*B3)*SRH + 2.D0*B1*
     1        (7.D0 - 48.D0*B2)*CRH)/3.D0
       Q(4) = -16.D0*B2*((1.D0 - 3.D0*B2)*SRH + 3.D0*B1*CRH)/3.D0
       Q(5) = B1*(B1*(11.D0 - 24.D0*B2)*SRH - 3.D0*(1.D0 - 8.D0*B2)*
     1        CRH)/3.D0
   40  CONTINUE
       CALL FUN(A,R,IND)
       DO 80 J = 1, K1
          ARG = A + (2.D0*J - 1.D0)*H2
          SN = DSIN(ARG*RO+FI)
          CS = DCOS(ARG*RO+FI)
          DO 50 I = 1, N
             V = Q(3)*R(I,1)
             W = -Q(5)*R(I,1)
             R(I,2) = R(I,2) + SN*V + CS*W
             R(I,3) = R(I,3) + CS*V - SN*W
   50     CONTINUE
          J2 = 2
          J3 = 4
          J4 = -1
          DO 70 J1 = 1, 4
             CALL FUN(ARG + (J1 - 2.D0)*H4,R,IND)
             DO 60 I = 1, N
                V = Q(J2)*R(I,1)
                W = J4*Q(J3)*R(I,1)
                R(I,2) = R(I,2) + SN*V + CS*W
                R(I,3) = R(I,3) + CS*V - SN*W
   60        CONTINUE
             J2 = J1
             J3 = J1 + 2
             J4 = 1
             IF (J1 .EQ. 1) J4 = 0
   70     CONTINUE
   80  CONTINUE
       KW = 1
       DO 90 I = 1, N
          IF (IND(I) .GT. 0) GO TO 90
             R(I,2) = R(I,2)*H2
             R(I,3) = R(I,3)*H2
             ES = DABS(RINT(I,1) - R(I,2))*L1/(1.D0 + DABS(R(I,3)))
             EC = DABS(RINT(I,IL) - R(I,3))*L2/(1.D0 + DABS(R(I,3)))
             IF (ES .LE. EPS .AND. EC .LE. EPS) IND(I) = K1*WK
             IF (IND(I) .EQ. 0) KW = 0
             RINT(I,1) = R(I,2)
             IF (L2 .NE. 0) RINT(I,IL) = R(I,3)
             R(I,2) = 0.D0
             R(I,3) = 0.D0
   90  CONTINUE
       IF (EPS .LE. 0.D0 .OR. KW .GT. 0) GO TO 100
          K1 = K1 + K1
          WK = .5D0
          IF (K1 .LE. 1048576) GO TO 20
             IERR = 65
             CALL UTQS12(IERR,11)
  100     RETURN
      END
